Bug 14491 - Overlapping text elements
Summary: Overlapping text elements
Status: UNCONFIRMED
Alias: None
Product: WebKit
Classification: Unclassified
Component: WebKit Misc. (show other bugs)
Version: 523.x (Safari 3)
Hardware: Macintosh PowerPC OS X 10.4
: P2 Normal
Assignee: Nobody
URL: http://webkit.org/building/run.html
Keywords:
Depends on:
Blocks:
 
Reported: 2007-07-01 15:44 PDT by Sean Dynan
Modified: 2007-10-13 07:00 PDT (History)
1 user (show)

See Also:


Attachments
Screenshot of the offending web page (42.59 KB, image/png)
2007-07-01 15:46 PDT, Sean Dynan
no flags Details
Screenshot of the Rails "Welcome Aboard" page (42.81 KB, image/png)
2007-07-01 15:59 PDT, Sean Dynan
no flags Details
HTML source of the Rails "Welcome Aboard" page (7.38 KB, text/html)
2007-07-01 16:00 PDT, Sean Dynan
no flags Details
Weird text rendering in nightly r23841 (37.41 KB, image/png)
2007-07-01 16:35 PDT, Sean Dynan
no flags Details
Courier font that might be misbehaving (376.86 KB, application/octet-stream)
2007-10-13 07:00 PDT, Sean Dynan
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Sean Dynan 2007-07-01 15:44:32 PDT
Safari 3.0.2 with WebKit nightly (r23841), and the stock Safari 3.0.2 (without WebKit).

Fixed-width and variable-width text elements are rendered overlapped.

The WebKit page URL I have included is a classic case in point. But it happens just about everywhere. Here's another one: http://java.sun.com/j2se/1.5.0/docs/api/java/lang/StringBuilder.html (scroll down to the Method Summary table).

I find the situation so unlikely that I'm willing to believe it's something to do with the font set-up on my box, though I can't imagine what, since I don't really mess with fonts.
Comment 1 Sean Dynan 2007-07-01 15:46:48 PDT
Created attachment 15338 [details]
Screenshot of the offending web page

Partial screenshot of http://webkit.org/building/run.html as seen on Safari 3.0.2, with or without WebKit Nightly.
Comment 2 Sean Dynan 2007-07-01 15:58:42 PDT
Okay - some clarification:

Stock Safari 3.0.2 isn't as bad as nightly r23841.  The links I gave for Running WebKit page and the Java StringBuilder page render fine, as expected. My mistake.

But the same overlapping text symptom can be seen when viewing the Ruby on Rails "Welcome Aboard" page. I will upload a partial screenshot of the Rails page and the HTML behind it.
Comment 3 Sean Dynan 2007-07-01 15:59:38 PDT
Created attachment 15339 [details]
Screenshot of the Rails "Welcome Aboard" page
Comment 4 Sean Dynan 2007-07-01 16:00:38 PDT
Created attachment 15340 [details]
HTML source of the Rails "Welcome Aboard" page
Comment 5 Sean Dynan 2007-07-01 16:06:44 PDT
It gets weirder...

I can't even correctly select blocks of text from this Bugzilla page in the latest Webkit nightly as if, for example, I wanted to paste it into TextEdit.

And now that I compare the quality of text rendering between WebKit Safari and stock Safari, I notice that something is afoot.

I will upload yet another PNG for your amusement.
Comment 6 Sean Dynan 2007-07-01 16:35:22 PDT
Created attachment 15342 [details]
Weird text rendering in nightly r23841
Comment 7 David Kilzer (:ddkilzer) 2007-07-07 08:23:31 PDT
I don't see a rendering issue with a local debug build of WebKit r24013 using Safari 3.0 (522.12) on Mac OS X 10.4.10 (8R218).

Have you changed your "Standard font" and/or "Fixed-width font" settings in Safari to be something other than the default?  Mine are:

Standard font:  Times 16
Fixed-width font:  Courier 13

Do you have any Safari extensions installed (like Saft, PithHelmet, SafariStand)?
Comment 8 Sean Dynan 2007-07-09 08:23:22 PDT
I no longer experience this problem right now. So I guess I'm wearing egg on my face. The problem as described does periodically exhibit itself, and has done for months, but I have absolutely no idea what might be behind it. I don't have any Safari extensions installed and my fonts are all kosher (as far as I can tell: Font Book has no complaints). So, sorry for wasting your time.
Comment 9 David Kilzer (:ddkilzer) 2007-07-09 09:04:19 PDT
(In reply to comment #8)
> I no longer experience this problem right now. So I guess I'm wearing egg on my
> face. The problem as described does periodically exhibit itself, and has done
> for months, but I have absolutely no idea what might be behind it. I don't have
> any Safari extensions installed and my fonts are all kosher (as far as I can
> tell: Font Book has no complaints). So, sorry for wasting your time.

It could be a race condition which is hard to reproduce.  Let's keep this bug open for a while.  If you see it again (or get any insight into how to reproduce it more often), just add it to the bug.  Thanks!

Comment 10 Sean Dynan 2007-10-04 13:24:37 PDT
(In reply to comment #9)
> It could be a race condition which is hard to reproduce.  Let's keep this bug
> open for a while.  If you see it again (or get any insight into how to
> reproduce it more often), just add it to the bug.  Thanks!

Right - this problem never really went away for me, neither in WebKit or stock Safari. It is reproducible 100% of the time, even after full reboots.

I have methodically removed any and all Safari and Internet plug-ins, but to no avail.

Tonight I have managed to narrow it down to using Courier as my fixed-width font in Safari. All other fixed-width fonts (and I have a lot) render perfectly. The only one that produces that weird overlapping behaviour is Courier. And it overlaps no matter what point size I choose. And it overlaps no matter what I choose for Safari's Standard Font.

Fontbook validates Courier with no problems at all. So, all I can assume is that the Courier font I am left with is maybe corrupt or a doppelgŠnger.

Can I mail you my Courier font for you to try on your own set-up?
Comment 11 Sean Dynan 2007-10-04 13:39:32 PDT
(In reply to comment #10)
> Tonight I have managed to narrow it down to using Courier as my fixed-width
> font in Safari.

I just checked: my Courier renders fine in Firefox and Camino. But, using Courier whilst trying to type into Bugzilla's comments box was a nightmare! Backspacing wouldn't erase characters, lines of characters were clipped even though a copy-n-paste into a text editor showed the characters were still intact...

There's something fishy on my machine...hopefully just that font :-(  It's almost like OS X doesn't really 'see' it as monospaced.
Comment 12 David Kilzer (:ddkilzer) 2007-10-04 20:12:29 PDT
(In reply to comment #10)
> Fontbook validates Courier with no problems at all. So, all I can assume is
> that the Courier font I am left with is maybe corrupt or a doppelgŠnger.
> 
> Can I mail you my Courier font for you to try on your own set-up?

Is this not the Courier font that comes with OS X?  Feel free to send me a copy if you'd like.
Comment 13 Sean Dynan 2007-10-05 01:52:25 PDT
(In reply to comment #12)
> Is this not the Courier font that comes with OS X?  Feel free to send me a copy
> if you'd like.

Since then, I have copied the Courier font from my PowerBook (where there are no Safari font problems) onto my PowerMac and tried again. But I still see the same problem. So I guess it's not the font. Weird. I guess I'll wipe the machine when I get Leopard - that'll fix the 'bug' ;-)

Comment 14 David Kilzer (:ddkilzer) 2007-10-05 08:40:47 PDT
(In reply to comment #13)
> Since then, I have copied the Courier font from my PowerBook (where there are
> no Safari font problems) onto my PowerMac and tried again. But I still see the
> same problem. So I guess it's not the font. Weird. I guess I'll wipe the
> machine when I get Leopard - that'll fix the 'bug' ;-)

Do you have any haxies or Input Managers (like Saft, SafariStand, PithHelmet, or others) installed?  If so, try removing those to see if that fixes the issue.  (Launching the WebKit nightly build will complain about such things if it finds them.)

It's too bad something like Conflict Catcher does exist for OS X.  It would have let you do a binary search of your fonts (disabling half your fonts, testing, disabling the other half, testing, etc. until a suspect font was found).

Comment 15 Sean Dynan 2007-10-13 06:58:10 PDT
Definitely no haxies or Saft or anything and Webkit doesn't argue when it starts up (like it used to before I removed every input manager I could find, not that there were many to begin with).

It's a good one, isn't it? It's also interesting that Gecko doesn't like that font much either. I'll upload the font file anyway just in case it really *is* to blame.
Comment 16 Sean Dynan 2007-10-13 07:00:31 PDT
Created attachment 16652 [details]
Courier font that might be misbehaving

Courier font that might be misbehaving.